package com.qmth.distributed.print.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.distributed.print.business.entity.ClientStatus;
import com.qmth.distributed.print.business.mapper.ClientStatusMapper;
import com.qmth.distributed.print.business.service.ClientStatusService;
import com.qmth.distributed.print.common.contant.SystemConstant;
import org.springframework.stereotype.Service;

/**
 * @Date: 2021/4/19.
 */
@Service
public class ClientStatusServiceImpl extends ServiceImpl<ClientStatusMapper, ClientStatus> implements ClientStatusService {
    @Override
    public Boolean tagPass(Long schoolId, Long examTaskId, String machineCode, Boolean isPass, Long userId) {
        QueryWrapper<ClientStatus> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(ClientStatus::getSchoolId, schoolId).eq(ClientStatus::getExamTaskId, examTaskId).eq(ClientStatus::getMachineCode, machineCode);
        ClientStatus clientStatus = this.getOne(queryWrapper);
        if(clientStatus != null){
            clientStatus.setPass(isPass);
            clientStatus.setUpdateId(userId);
            clientStatus.setUpdateTime(System.currentTimeMillis());
            return this.updateById(clientStatus);
        } else {
            clientStatus = new ClientStatus();
            clientStatus.setId(SystemConstant.getDbUuid());
            clientStatus.setSchoolId(schoolId);
            clientStatus.setMachineCode(machineCode);
            clientStatus.setExamTaskId(examTaskId);
            clientStatus.setTry(true);
            clientStatus.setTryTime(System.currentTimeMillis());
            clientStatus.setPass(isPass);
            clientStatus.setCreateId(userId);
            clientStatus.setCreateTime(System.currentTimeMillis());
            return this.save(clientStatus);
        }
    }
}
